package rip.iwakura.civilcore;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;

import org.bukkit.Bukkit;
import org.bukkit.WorldCreator;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import net.md_5.bungee.api.ChatColor;
import rip.iwakura.civilcore.commands.TeamChatCommand;
import rip.iwakura.civilcore.commands.TeamCommand;
import rip.iwakura.civilcore.discord.Discord;

public class CivilCore extends JavaPlugin {
  public Database db = new Database();
  public Discord bot;
  public ArrayList<Player> teamChatRegister = new ArrayList<>();

  @Override
  public void onEnable() {
    this.saveDefaultConfig();

    this.bot = new Discord(getConfig().getString("discord.token"), getConfig().getString("discord.channel"), this);
    this.bot.initialize();
    
    try {
		  Class.forName("org.postgresql.Driver");
	  } catch (ClassNotFoundException e) {
		  e.printStackTrace();
	  }

    try {
		  db.connect(this.getConfig().getString("database.url"));
	  } catch (SQLException e) {
		  e.printStackTrace();
	  }
    getServer().getPluginManager().registerEvents(new PlayerHandler(this), this);
    this.getCommand("team").setExecutor(new TeamCommand(this));
    this.getCommand("tc").setExecutor(new TeamChatCommand(this));
  }
}
