package rip.iwakura.civilcore;

import java.sql.SQLException;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerJoinEvent;

import net.md_5.bungee.api.ChatColor;
import rip.iwakura.civilcore.types.DbPlayer;

public class PlayerHandler implements Listener {

  private final CivilCore civilCore;

  public PlayerHandler(CivilCore civilCore) {
    this.civilCore = civilCore;
  }

  @EventHandler
  public void PlayerChat(AsyncPlayerChatEvent e) {
    e.setCancelled(true);

    Player p = e.getPlayer();
    String player_name = p.getName();
    boolean inTeamChat = civilCore.teamChatRegister.contains(p);

    DbPlayer dbPlayer = civilCore.db.getPlayerByName(player_name);
    String prefix = (inTeamChat ? ChatColor.DARK_GREEN + "TEAM >" + ChatColor.RESET : "")
      + (dbPlayer.team.prefix == null ?
        "" : 
        ChatColor.translateAlternateColorCodes('&', inTeamChat ? "" : "[" + dbPlayer.team.prefix + "]"));
    String message = String.format("%s %s: %s", prefix, player_name, e.getMessage());

    if (!inTeamChat) {
      Bukkit.broadcastMessage(message);
      civilCore.bot.sendMessage(e);
    } else {
      List<DbPlayer> players = civilCore.db.getPlayersInTeam(dbPlayer.team.name);

      if (players == null) return;

      for (DbPlayer team_dbp : players) {
        Player team_p = Bukkit.getPlayer(team_dbp.name);

        if (team_p == null) continue;

        team_p.sendMessage(message);
      }
    }

  }

  @EventHandler
  public void PlayerJoinEvent(PlayerJoinEvent e) {
    Player p = e.getPlayer();
    String player_name = p.getName();
    if(civilCore.db.getPlayerByName(player_name) == null) {
      DbPlayer dbPlayer = new DbPlayer(p.getName(), null);
      try {
		    civilCore.db.insertPlayer(dbPlayer);
	    } catch (SQLException e1) {
		    e1.printStackTrace();
	    }
    }

  }
}
